<?php
namespace Planejamento\Exception;

class ExceptionRetirada extends \Geral\Logic\Exception
{


    private $messageName;
    private $messageNameAcumulado;
    private $paramsAcumulado;


    public function __construct($messagemName, $param = null){
        parent::__construct($messagemName);
        $this->messageName = $messagemName;
        $this->addParam($param);
    }

    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return $this->messageName;
    }

    /**
     * Retorna o parametro da mensagem para esta excecao.
     *
     * @return string
     */
    public function getParam()
    {
        return $this->getParams();
    }


    public function acumulaMensagem($NmMensagem, $params){
        $this->messageNameAcumulado = $NmMensagem;
        $this->paramsAcumulado = $params;
    }


    public static function erroRetiradaExistente(){
        throw new self('pla02000_existeReti');
    }


    public static function erroQtdMenorZero(){
        throw new self('pla02000_qtdNegativa');
    }


    public static function erroExisteItemRetirada(){
        throw new self('pla02000_existeItemRetirada');
    }


    public static function erroQtNegativa(){
        throw new self('pla02000_qtdNegativa');
    }


    public static function erroNaoHaLancto(){
        throw new self('pla02000_naoHaLancamento');
    }


    public static function erroQtdNaoDisponivel($param = null) {
        if (empty($param) === true){
            throw new self('pla02000_qtdNaoDisponivel');
        } else {
            throw new self('pla02000_qtdNaoDisponivelParam', $param);
        }
    }

    public static function erroQtdDevolvida() {
            throw new self('pla02000_erroQtdDevolvida');
    }



}
