function cmp00100ProdutoPorFornecedorController(General, ScreenService,MessageService, metaDataFactory, templateManager, restEngine,ZhFilterPreferences, maskEngine, ZhUtil) {
    /*global Constants*/
    
    var self = this;
    
    this.setDataSourceFilter = function(args) {
        const row = args.e.preference.FILTER_ROW;
        const widget = args.owner;
        
        widget.dataSourceFilter = [
		    {
		        "name": "P_CDFORNECED",
		        "operator": "=",
		        "value": row.CDFORNECED
		    },
		    {
                "operator": "ORDER_BY",
                "name": [
                    {
                        "name": "CDARVPROD",
                        "direction": "ASC"
                    }
                ]
            }
		];
		
		self.setStripeValues(widget);
		
		widget.getAction('CADAUTO').readOnly = widget.appliedFilter.ID == 'ORIGINAL' ? true : false;
		widget.getAction('ALTERAUTO').readOnly = widget.appliedFilter.ID == 'ORIGINAL' ? true : false;
		
		widget.reload();
		widget.activate();
    };
    
    this.setStripeValues = function(widget) {
        const stripe = templateManager.container.getWidget('stripe');
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const mask = {
			type: "CPFCNPJ",
			params: {}
		};
        
        stripe.currentRow.NRINSJURFORN = Util.applyMask(filterRow.NRINSJURFORN, mask, maskEngine, ZhUtil);
        stripe.currentRow.NMFANTFORN = filterRow.NMFANTFORN;
        
        stripe.reload();
    };
    
    this.setFornecedorValuesWidgetExportar = function(widget) {
        if (widget.getParent().appliedFilter) {
            const widgetExportar = templateManager.container.getWidget("exportWidget");
            const currentRowWidget = widgetExportar.currentRow;
            const filterRow = widget.getParent().appliedFilter.FILTER_ROW;
            
            currentRowWidget.CDFORNECEDORIG   = filterRow.CDFORNECED;
            currentRowWidget.NRINSJURFORNORIG = filterRow.NRINSJURFORN;
            currentRowWidget.NMRAZSOCFORNORIG = filterRow.NMRAZSOCFORN;
            
            self.setFornDestDataFilter(widgetExportar);
        }
    };
    
    this.setReadOnlyFields = function(widget, arrayFields, value) {
        for (let field of arrayFields) {
            widget.getField(field).readOnly = value;
        }
    };
    
    this.setIsVisibleFields = function(widget, arrayFields, value) {
        for (let field of arrayFields) {
            widget.getField(field).isVisible = value;
        }
    };
    
    this.setFornDestDataFilter = function(widget) {
    	const arrayFields = ['NMRAZSOCFORNDEST', 'NMPRODINI', 'NMPRODFIN'];
    	
    	if (widget.currentRow.NMRAZSOCFORNORIG.length > 0) {
    	    self.setReadOnlyFields(widget, arrayFields, false);
    	    
    	    widget.getField('NMRAZSOCFORNDEST').dataSourceFilter = [
    		    {
    		        "name": "P_CDFORNECED",
    		        "operator": "=",
    		        "value": widget.currentRow.CDFORNECEDORIG
    		    }   
    		];
    	} else {
    	    self.setReadOnlyFields(widget, arrayFields, true);
    	}
    };
    
    this.openSubGridFilter = function(widget) {
        const subGridwidget = templateManager.container.getWidget('atendidaSubGrid');
        const currentRowWidget = widget.currentRow;
        
        ScreenService.openSwipe(subGridwidget);
        
        subGridwidget.dataSourceFilter = [
        	{
        		"name": "P_SGESTADO",
		        "operator": "=",
		        "value": currentRowWidget.SGESTADO	
        	},
        	{
        		"name": "P_CDMUNICIPIO",
		        "operator": "=",
		        "value": currentRowWidget.CDMUNICIPIO	
        	},
        	{
        		"name": "P_CDFORNECED",
		        "operator": "=",
		        "value": currentRowWidget.CDFORNECED	
        	},
        	{
        		"name": "P_CDPAIS",
		        "operator": "=",
		        "value": currentRowWidget.CDPAIS	
        	}
        ];
    };
    
    this.openFormSubGrid = function(widget) {
        const formSubGridwidget = templateManager.container.getWidget('formSubGrid');
        const currentRowSubGridWidget = formSubGridwidget.currentRow;
        const currentRowWidget = widget.currentRow;
        
        ScreenService.openSwipe(formSubGridwidget).then(function(success) {
        	formSubGridwidget.edit();
        });
        
        currentRowSubGridWidget.CDFILIAL   = currentRowWidget.CDFILIAL;
        currentRowSubGridWidget.NMFILIAL   = currentRowWidget.NMFILIAL;
        currentRowSubGridWidget.CDPERIENTR = currentRowWidget.CDPERIENTR;
        currentRowSubGridWidget.NMPERIENTR = currentRowWidget.NMPERIENTR;
    };
    
    this.saveProduto = function(widget) {
        if (widget.isValid()) {
            let currentRowWidget = widget.currentRow;
            currentRowWidget.CDFORNECED = widget.getParent().appliedFilter.FILTER_ROW.CDFORNECED;
            currentRowWidget.NRORG = getLocalVar('NRORG');
            currentRowWidget.CDFORNORIG = null;
            currentRowWidget.CDMARCA = null;
            currentRowWidget.ARRED = 'P';
            
        	General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/saveProduto','Row', currentRowWidget).then(function(res) {
        	   currentRowWidget = {};
        	   MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
        	   ScreenService.closePopup();
        	   widget.getParent().reload();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.saveProdutoNvlCompleto = function(widget) {
        if (widget.isValid()) {
            let currentRowWidget = widget.currentRow;
            const currentRowWidProdutos = widget.container.getWidget('produtos').currentRow;
            
            currentRowWidget.VRPERPIPRFO = currentRowWidget.VRPERPIPRFO ? currentRowWidget.VRPERPIPRFO : null;
            currentRowWidget.VRARREDCMPFO = currentRowWidget.VRARREDCMPFO ? currentRowWidget.VRARREDCMPFO : null;
            currentRowWidget.CDEXPRODFORN = currentRowWidget.CDEXPRODFORN ? currentRowWidget.CDEXPRODFORN : null;
            currentRowWidget.VRARREDEMPE = currentRowWidget.VRARREDEMPE ? currentRowWidget.VRARREDEMPE : null;
            currentRowWidget.VRPERVARPREPRFO = currentRowWidget.VRPERVARPREPRFO ? currentRowWidget.VRPERVARPREPRFO : null;
            currentRowWidget.NRDIASVALPRFORN = currentRowWidget.NRDIASVALPRFORN ? currentRowWidget.NRDIASVALPRFORN : null;
            currentRowWidget.CDPRODCOMPL = currentRowWidget.CDPRODUTO;
            
            currentRowWidget.CDFORNECED = currentRowWidProdutos.CDFORNECED;
            currentRowWidget.CDPRODUTO = currentRowWidProdutos.CDPRODUTO;
            currentRowWidget.NRORG = getLocalVar('NRORG');
                        
            General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/saveProdutoNvlCompleto','Row', currentRowWidget).then(function(res) {
                currentRowWidget = {};
                ScreenService.closeSwipe().then(function(success){
                    widget.reload();
                    MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
                });
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.deleteProduto = function(widget) {
        ScreenService.confirmMessage('Deletar registro?', 'question', function(success) {
            let produtoArray = [];
            
            widget.dataSource.data.forEach(function(produto) {
                if (produto.__isSelected) {
                    produtoArray.push(produto);
                }
            });

        	General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/deleteProduto','Row', produtoArray).then(function(res) {
                widget.unSelectAll();
                widget.reload();
                MessageService.successNotificationByCode("REG_SUCCESS_DELETE");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    this.exportProduto = function(widget) {
        const currentRowWidget = widget.currentRow;
        
        if (widget.isValid() && self.validaProduto(currentRowWidget.CDARVPRODINI, currentRowWidget.CDARVPRODFIN)) {
            
            currentRowWidget.CDFORNECEDDEST = currentRowWidget.CDFORNECEDDEST ? Array.isArray(currentRowWidget.CDFORNECEDDEST) ? currentRowWidget.CDFORNECEDDEST : 'T' : 'T';
        	currentRowWidget.NRORG = getLocalVar('NRORG');
        	
        	if (widget.getField('TODOS').checked) {
        	    currentRowWidget.EXPROD = 'T';
        	} else if (widget.getField('INTERPROD').checked) {
        	    currentRowWidget.EXPROD = 'I';
        	} else {
        	    currentRowWidget.EXPROD = null;
        	}
        	
            currentRowWidget.CDARVPRODFIN = self.preencheCaracterDireta(currentRowWidget.CDARVPRODFIN);
            
        	General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/exportProduto','Row', currentRowWidget).then(function(res) {
        	    ScreenService.closePopup();   
        	    widget.getParent().reload();
        	    MessageService.showMessageByCode("EXPORT_SUCCESS");
        	    
                currentRowWidget.NMPRODFIN = "";
                currentRowWidget.NMPRODINI = "";
                currentRowWidget.NMRAZSOCFORNDEST = "";
                currentRowWidget.NMRAZSOCFORNORIG = "";
                currentRowWidget.TODOS = "N";
                currentRowWidget.ARRENDEMP = "N";
                currentRowWidget.INTERPROD = "N";
                
                MessageService.successNotificationByCode("EXPORT_SUCCESS");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.generateReport = function(widget){
        const currentRowWidget = widget.currentRow;
        
        if (widget.isValid() && self.validaProduto(currentRowWidget.CDARVPRODINI, currentRowWidget.CDARVPRODFIN)) {
        	const reportName = widget.currentRow.REPORT;
        	
        	currentRowWidget.NRORG = getLocalVar('NRORG');
        	currentRowWidget.CDFORNECED = currentRowWidget.CDFORNECED ? Array.isArray(currentRowWidget.CDFORNECED) ? currentRowWidget.CDFORNECED : 'T' : 'T';
        	
        	General.openReportPopup(widget, self.abreRelatorio, [widget, currentRowWidget, reportName]);
        }
    };
    
    this.abreRelatorio = function(widget, row, reportName) {
        General.openReport('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/generateReport', reportName, row).then(function(success) {
            row.NMPRODINI = "";
            row.NMPRODFIN = "";
            row.CDARVPRODINI = "";
            row.CDARVPRODFIN = "";
            row.CDPRODINI = "";
            row.CDPRODINI = "";
            row.CDFORNECED = "";
            row.NMRAZSOCFORN = "";
            row.NRINSJURFORN = "";
            row.FORNECEDOR = "";
        });
    };
    
    this.controlaCheckBox = function(field) {
        let otherField = "";
        
        if (field.name == 'TODOS') {
            otherField = field.widget.getField('INTERPROD');
        } else {
            otherField = field.widget.getField('TODOS');
        }
        
        if (field.checked) {
            otherField.checked = false;
        } else {
            field.checked = false;
        }
    };
    
    this.setDataSourceNvlCompleto = function(widget) {
    	const currentRowWidProdutos = widget.container.getWidget('produtos').currentRow;
    	
	    widget.dataSourceFilter = [
		    {
		        "name": "P_CDPRODUTO",
		        "operator": "=",
		        "value": currentRowWidProdutos.CDPRODUTO
		    },
		    {
		        "name": "P_CDFORNECED",
		        "operator": "=",
		        "value": currentRowWidProdutos.CDFORNECED
		    }
		];
		
		widget.reload();
    };
    
    this.controlaProdField = function(field) {
        const getFieldProduto = field.widget.getField('NMPRODUTO');
        const currentRowWidget = field.widget.currentRow;
        
        getFieldProduto.readOnly = field.checked ? false : true;
        
        if (getFieldProduto.readOnly == true) {
            currentRowWidget.NMPRODUTO = "";
        } else {
            currentRowWidget.CDPRODUTO = (currentRowWidget.CDPRODUTO && Array.isArray(currentRowWidget.NMPRODUTO)) ? currentRowWidget.NMPRODUTO : 'T';
        }
    };
    
    
    this.addFilial = function(widget) {
        if (widget.appliedFilter.ID == 'ORIGINAL') {
            ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('naoAtendida'));
            MessageService.showMessageByCode("NECE_FORN_FILTER");
        } else {
            self.openChildWidgets(widget, 0);
        }
    };
    
    this.backSwipe = function(args) {
    	args.owner.widget.currentRow = {};
    	ScreenService.closePopup();
    };
    
    this.backPopup = function(widget) {
    	const nameWidget = widget.name;
    	widget.currentRow = {};
    	
    	if (nameWidget == templateManager.container.getWidget('reportWidget').name) {
    	    widget.currentRow.REPORT = "CMP00301";
    	}
    	
    	ScreenService.closePopup();
    };
    
    this.editSwipe = function(widget) {
    	General.widgetEdit(widget);
    };
    
    this.openFormSwipe = function(widget) {
        const widTabSwipe = templateManager.container.getWidget('tabSwipe');
        const widModoPagamento = templateManager.container.getWidget('modopagamento');
        const widProdutoNivelCompleto = templateManager.container.getWidget('produtosNvlCompleto');
        
        const currentRowWidget = widget.currentRow;
        const currentRowWidPagamento = templateManager.container.getWidget('pagamento').currentRow;
        
        widProdutoNivelCompleto.enabled = true;
        widModoPagamento.list();
        
        self.setFieldsOpcaoPagamentoWidPrin(widget);
        
        ScreenService.openSwipe(widTabSwipe).then(function(success) {
            currentRowWidPagamento.QTMINAF = currentRowWidget.QTMINAF;
            currentRowWidPagamento.SGUNIDADE = currentRowWidget.SGUNIDADE;
            currentRowWidPagamento.QTDIASENTR = currentRowWidget.QTDIASENTR;
            currentRowWidPagamento.IDTPFORPGTFO = currentRowWidget.IDTPFORPGPRF;
            currentRowWidPagamento.NRDIAPGFIXFO = currentRowWidget.NRDIAPGFIPRF;
            currentRowWidPagamento.NRPARCPGTOFO = currentRowWidget.NRPARCPGTPRF;
            currentRowWidPagamento.IDUTDIAPGTFO = currentRowWidget.IDUTDIAPGPRF;
            currentRowWidPagamento.NMFORMPGTO = currentRowWidget.NMFORMPGTO;
            
            self.setDataSourceNvlCompleto(widProdutoNivelCompleto);
            self.setFieldsOpcaoPagamento(widget);
            self.setGridPagamento(widget);
            
            widTabSwipe.widgets[0].activate();
        });
    };
    
    this.openChildWidgets = function(widget, widNumber) {
        ScreenService.openPopup(widget.widgets[widNumber]).then(function(success){
        	widget.widgets[widNumber].edit();
        }); 
    };
    
    this.setDefaultFornecedorCadAuto = function (widget) {
        let parentWidgetFilterRow = widget.getParent().appliedFilter.FILTER_ROW;
        let row = widget.currentRow;
        
        row.NMFANTFORN = [parentWidgetFilterRow.NMFANTFORN];
        row.CDFORNECED = [parentWidgetFilterRow.CDFORNECED];
        row.NRINSJURFORN = [parentWidgetFilterRow.NRINSJURFORN];
        row.IDTPIJURFORN = [parentWidgetFilterRow.IDTPIJURFORN];
        row.NMRAZSOCFORN = [parentWidgetFilterRow.NMRAZSOCFORN];
    };
    
    this.cadProduto = function(widget) {
        const currentRowWidget = widget.currentRow;
        
        if (widget.isValid() && self.validaProduto(currentRowWidget.CDARVPRODINI, currentRowWidget.CDARVPRODFIN)) {
            
            currentRowWidget.NRORG = getLocalVar('NRORG');
            
            General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/cadProdAuto','Row', currentRowWidget).then(function(res){
        	    currentRowWidget.CDFORNECED = "";
        	    currentRowWidget.NMPRODINI = "";
        	    currentRowWidget.NMPRODFIN = "";
        	    
        	    ScreenService.closePopup();
        	    widget.getParent().reload();
        	    MessageService.successNotificationByCode("OPR_SUCCESS");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.alterProduto = function(widget) {
        let currentRowWidget = widget.currentRow;
        
        if (widget.isValid() && self.validaProduto(currentRowWidget.CDARVPRODINI, currentRowWidget.CDARVPRODFIN)) {
            
            currentRowWidget.CDFORNECED = widget.getParent().appliedFilter.FILTER_ROW.CDFORNECED;
            currentRowWidget.VRARREDCMPFO = currentRowWidget.VRARREDCMPFO ? currentRowWidget.VRARREDCMPFO : 0;
            currentRowWidget.PIDSV = currentRowWidget.PIDSV ? currentRowWidget.PIDSV : 0;
            currentRowWidget.EMPENHO = currentRowWidget.EMPENHO ? currentRowWidget.EMPENHO : 0;
            currentRowWidget.VARIAMAXIMO = currentRowWidget.VARIAMAXIMO ? currentRowWidget.VARIAMAXIMO : 0;
            currentRowWidget.VALIDADEDIAS = currentRowWidget.VALIDADEDIAS ? currentRowWidget.VALIDADEDIAS : 0;
            currentRowWidget.CDPRODUTO = (currentRowWidget.CDPRODUTO && widget.getField('NMPRODUTO').readOnly == false && Array.isArray(currentRowWidget.NMPRODUTO)) ? currentRowWidget.NMPRODUTO : 'T'; 
            
            General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/altProdAuto','Row', currentRowWidget).then(function(res){
        	    ScreenService.closePopup();   
        	    ScreenService.closePopup();   
        	    MessageService.showMessageByCode("OPR_SUCCESS");
        	    
        	    currentRowWidget.NMPRODINI = "";
        	    currentRowWidget.CDPRODINI = "";
        	    currentRowWidget.CDARVPRODINI = "";
        	    currentRowWidget.NMPRODFIN = "";
        	    currentRowWidget.CDPRODFIN = "";
        	    currentRowWidget.CDARVPRODFIN = "";
        	    currentRowWidget.NMPRODUTO = "";
        	    currentRowWidget.CONSIDERA = "";
                currentRowWidget.CDFORNECED = "";
                currentRowWidget.VRARREDCMPFO = "";
                currentRowWidget.PIDSV = "";
                currentRowWidget.EMPENHO = "";
                currentRowWidget.VARIAMAXIMO = "";
                currentRowWidget.VALIDADEDIAS = "";
                currentRowWidget.CDPRODUTO = "";
                currentRowWidget = {};
                
                widget.getField('NMPRODUTO').readOnly = true;
        	    widget.getField('CONSIDERA').checked = false;
        	    widget.getParent().reload();
        	    
        	    MessageService.successNotificationByCode("OPR_SUCCESS");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.validaProduto = function(prodInicial, prodFinal) {
        if (!General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode("PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
            return false;
        }

        return true;
    }; 
    
    this.saveFormaPagamento = function(widget) {
        if (widget.getParent().isValid()) {
            const currentRowParentWidget = widget.getParent().currentRow;
            let dataArray = [];
            
            dataArray.push(widget.dataSource.data);
            dataArray.push(currentRowParentWidget);
            
            if (currentRowParentWidget.IDTPFORPGTFO == 'V' && !dataArray[0][0]) {
                MessageService.showMessageByCode("INFO_DIAS_PRAZO_PAGMTO");
                self.openFormaPgto(widget);
            } else {
                const widProdutos = widget.container.getWidget('produtos');
                const currentRowWidProdutos = widProdutos.currentRow;
                
                currentRowParentWidget.CDFORNECED = currentRowWidProdutos.CDFORNECED;
                currentRowParentWidget.CDPRODUTO = currentRowWidProdutos.CDPRODUTO;
                currentRowParentWidget.CDFORMPGTO = currentRowParentWidget.CDFORMPGTO || currentRowWidProdutos.CDFORMPGTO;
                currentRowParentWidget.QTDIASENTR = currentRowParentWidget.QTDIASENTR || null;
                currentRowParentWidget.QTMINAF = currentRowParentWidget.QTMINAF || null;
                currentRowParentWidget.NRORG = getLocalVar('NRORG');
            
                if (currentRowParentWidget.IDTPFORPGTFO == null) {
                    currentRowParentWidget.NRPARCPGTOFO = null;
                    currentRowParentWidget.NRDIAPGFIXFO = null;
                    currentRowParentWidget.CDFORMPGTO = null;
                }
                
            	General.callRestEngine('cmp_cadastros#/cmp00100ProdutoPorFornecedorController/saveFormaPagamento','Row', dataArray).then(function(res){
            	    const widProdutoNivelCompleto = templateManager.container.getWidget('produtosNvlCompleto');
            	    
            	    widget.currentRow = {};
                    widget.list();
            	    widProdutos.reload();
            	    widProdutoNivelCompleto.enabled = true;
            	    
            	    self.controlFields(widget.getParent(), true);
            	    MessageService.successNotificationByCode("REG_SUCCESS_SAVE");
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                });
            }
        }
    };
    
    this.savePrazos = function(widget) {
        if (widget.isValid()) {
            const dataSet = self.montaDataSet(widget.currentRow);
            
            if (self.validaDias(dataSet) && self.validaPercentual(dataSet)) {
                const parentWidget = widget.getParent();
                
                parentWidget.dataSource.data = self.montaDataSet(widget.currentRow);
                parentWidget.edit();
                parentWidget.activate();
                
                self.closeFormaPgto(widget);
            }
        }
    };
    

    this.setCurrentRowForm = function (widget) {
        if (widget.dataSource.data.length) {
            const item = widget.dataSource.data[0];
            
            for (let prop in item) {
                if (prop != 'SGUNIDADE') {
                    widget.currentRow[prop] = item[prop];
                }
            }
        }
    };
    
    this.setFieldsOpcaoPagamento = function(widget) {
        const widgetModoPagamento = widget.container.getWidget('modopagamento');
        const widgetPagamento = widget.container.getWidget('pagamento');
        
        switch (widgetPagamento.currentRow.IDTPFORPGTFO) {
            case "V":
                widgetPagamento.currentRow.IDUTDIAPGTFO = 'E';
                self.habilitaGrid(widgetModoPagamento);
                self.formaPagamento(widgetPagamento);
                break;
                
            case "F": 
                self.initializeFieldsOpcaoPagamentoFixo(widgetPagamento);
                self.desabilitaGrid(widgetModoPagamento);
                self.pagamentoFixo(widgetPagamento);
                break;
                
            default: 
                widgetPagamento.currentRow.IDUTDIAPGTFO = 'E';
                self.desabilitaGrid(widgetModoPagamento);
                self.desabilitaFields(widgetPagamento);
                break;
        }
    };
    
    this.initializeFieldsOpcaoPagamentoFixo = function(widget) {
        const currentRowWidget = widget.currentRow;
        
        currentRowWidget.IDUTDIAPGTFO = (currentRowWidget.IDUTDIAPGTFO != "" && currentRowWidget.IDUTDIAPGTFO != null) ? currentRowWidget.IDUTDIAPGTFO : "E";
        currentRowWidget.NRDIAPGFIXFO = (currentRowWidget.NRDIAPGFIXFO != "" && currentRowWidget.NRDIAPGFIXFO != null) ? currentRowWidget.NRDIAPGFIXFO : "1";
        currentRowWidget.NRPARCPGTOFO = (currentRowWidget.NRPARCPGTOFO != "" && currentRowWidget.NRPARCPGTOFO != null) ? currentRowWidget.NRPARCPGTOFO : "1";
    };
    
    this.setFieldsOpcaoPagamentoWidPrin = function(widget) {
        const widgetModoPagamento = widget.container.getWidget('modopagamento');
        const widgetPagamento = widget.container.getWidget('pagamento');
        
        switch (widget.currentRow.IDTPFORPGPRF) {
            case "V": 
                self.habilitaGrid(widgetModoPagamento);
                self.formaPagamento(widgetPagamento);
                break;
                
            case "F": 
                self.desabilitaGrid(widgetModoPagamento);
                self.pagamentoFixo(widgetPagamento);
                break;
                
            default: 
                self.desabilitaFields(widgetPagamento);
                self.desabilitaGrid(widgetModoPagamento);
                break;
        }
    };
    
    this.desabilitaFields = function(widget) {
        const arrayFields = ['NRDIAPGFIXFO', 'NRPARCPGTOFO', 'IDUTDIAPGTFO', 'NMFORMPGTO'];
        
        self.setIsVisibleFields(widget, arrayFields, false);
    };
    
    this.habilitaGrid = function(widget) {
        widget.isVisible = true;
        widget.getAction('SAVE').isVisible = true;
        widget.getAction('ADD').isVisible = true;
    };
    
    this.desabilitaGrid = function(widget) {
        widget.isVisible = false;
        widget.getAction('SAVE').isVisible = true;
        widget.getAction('ADD').isVisible = false;
    };
    
    this.formaPagamento = function(widget) {
        const arrayFieldsFalse = ['NRDIAPGFIXFO', 'NRPARCPGTOFO', 'IDUTDIAPGTFO'];
        const arrayFieldsTrue = ['NMFORMPGTO'];
        
        self.setIsVisibleFields(widget, arrayFieldsFalse, false);
        self.setIsVisibleFields(widget, arrayFieldsTrue, true);
        
        widget.getField("IDTPFORPGTFO").setValue("V");
    };
    
    this.pagamentoFixo = function(widget) {
        const arrayFieldsFalse = ['NMFORMPGTO'];
        const arrayFieldsTrue = ['NRDIAPGFIXFO', 'NRPARCPGTOFO', 'IDUTDIAPGTFO'];
        
        self.setIsVisibleFields(widget, arrayFieldsFalse, false);
        self.setIsVisibleFields(widget, arrayFieldsTrue, true);
        
        //widget.getField("IDUTDIAPGTFO").setValue("E");
    };
    
    this.setWidgetEdit = function(widget) {
        const parentWidget = widget.getParent();
        
        parentWidget.backupRow = angular.copy(parentWidget.currentRow); 
        templateManager.container.getWidget('produtosNvlCompleto').enabled = false;
        
        self.controlFields(parentWidget, false);
        widget.edit();
    };
    
    this.cancelFormaPgto = function(widget) {
        const parentWidget = widget.getParent();
        
        parentWidget.currentRow = parentWidget.backupRow;
        templateManager.container.getWidget('produtosNvlCompleto').enabled = true;
        
        self.controlFields(parentWidget, true);
        widget.list();
    };
    
    this.controlFields = function(widget, boll) {
        widget.fields.forEach(function(field) {
            field.readOnly = boll;
        }); 
        
        widget.getField('NRDIAPGFIXFO').spin = !boll;
        widget.getField('NRPARCPGTOFO').spin = !boll;
    };
    
    
    this.backWidgetProduto = function(widget, boll) {
       const widProdutos = widget.container.getWidget('produtos');
       ScreenService.closeSwipe();
       widProdutos.activate();
    };
    
    this.openFormaPgto = function(widgetGrid) {
        if (templateManager.container.getWidget('pagamento').getField('NMFORMPGTO').value()) {
            const widgetForm = widgetGrid.widgets[0];
            const data = widgetGrid.dataSource.data;
            
            data.forEach(function () {
                self.createAndAppendFields(widgetForm);
            });
            
            if (widgetForm.fields.length === 0) {
                self.createAndAppendFields(widgetForm);
            }
            
            widgetForm.currentRow = self.montaRow(data, widgetGrid.getParent().currentRow.CDFORNECED);
            ScreenService.openSwipe(widgetForm);
        } else {
            MessageService.showMessageByCode("FORMA_PGTO_INFO");
        }
    };
    
    this.createAndAppendFields = function(widget) {
        widget.fields = widget.fields.concat(self.getFields(self.numRowFormPgto, widget));
        
        self.numRowFormPgto++;
        self.hideDelete(widget);
    };
    
    this.numRowFormPgto = 0;
    
    this.montaRow = function(dataSet, cdForneced) {
        const row = {};
        
        for(var i in dataSet) {
            row['VRPERCPGTOFO' + i] = dataSet[i].VRPERCPGTOFO;
            row['NRDIASPGTOFO' + i] = dataSet[i].NRDIASPGTOFO;
        }
        
        row.CDFORNECED = cdForneced;
        
        return row;
    };
    
    this.hideDelete = function(widget) {
        const field = widget.getField('BTNDELETE0');
        
        if (self.numRowFormPgto <= 1) {
            field.isVisible = false;
        } else {
            field.isVisible = true;
        }
    };
    
    this.mascaraPercentual = function (field) {
        const pos = field.value().indexOf(",");
        const vrPercPgtoCl = field.value().replace(",", ".");
        
        if (vrPercPgtoCl > 100) {
            MessageService.showMessageByCode("VALOR_MENOR_100");
            field.widget.currentRow.VRPERCPGTOCL = field.widget.backupRow.VRPERCPGTOCL;
        } else if (pos != -1) {
            field.widget.currentRow.VRPERCPGTOCL = vrPercPgtoCl;
        }
    };
    
    this.getFields = function(index, widget) {
        let fields = [];
        
        fields.push(self.getFieldDias(index));
        fields.push(self.getFieldPercent(index));
        fields.push(self.getFieldDelete(index));
        
        for(let i in fields) {
            fields[i] = metaDataFactory.factoryField(fields[i], widget);
        }
        
        return fields;
    };
    
    this.getFieldDias = function(index) {
        return {
            name: "NRDIASPGTOFO" + index,
            label: ScreenService.i18n("Número (dias)"),
            template: "field/number.html",
            validations: {
                range: {
                    min: 0,
                    max: 999
                }
            },
            mask: {
                type: "number"
            },
            events: [
                {
                    name:"FieldOnChange",
                    code:"cmp00100ProdutoPorFornecedorController.validaDiaOnChange(args.owner.field.widget)"
                }
            ],
            defaultValue: '',
            isVisible: true,
            showOnList: true,
            showOnForm: true,
            class: 5
        };
    };
    
    this.validaDiaOnChange = function(widget) {
        let dataSet = self.montaDataSet(widget.currentRow);
        //self.validaDias(dataSet);
    };
    
    this.validaDias = function(dataSet) {
        let validacao = self.validaDiasPrazo(dataSet);
        
        if (!validacao) {
            MessageService.showMessageByCode("CADASTRO_PRAZO_UM");
        }
        
        return validacao;
    };

    this.validaDiasPrazo = function(dataSet) {
        let dias = [];
        
        dataSet.forEach(function(row) {
            dias.push(row.NRDIASPGTOFO);
        });
        
        for(let i in dias) {
            for(let j in dias) {
                if (i !== j && dias[i] === dias[j] ) {
                    return false;
                }
            }
        }
        return true;
    };
    
    this.validaPercentual = function(dataSet) {
        let validacao = self.validaPercent(dataSet);
        
        if (!validacao) {
            MessageService.showMessageByCode("SOMA_TOTAIS_PRAZO");
        }
        return validacao;
    };
    
    this.validaPercent = function(dataSet) {
        var percent = 0.0;
        
        dataSet.forEach(function(row) {
            percent += parseFloat(row.VRPERCPGTOFO);
        });
        
        return percent === 100;
    };
    
    
    this.montaDataSet = function(currentRow) {
        let dataSet = [];
        
        for(let i = 0; i < self.numRowFormPgto; i++) {
            dataSet[i] = {};
            dataSet[i].CDFORNECED = currentRow.CDFORNECED;
            dataSet[i].VRPERCPGTOFO = currentRow['VRPERCPGTOFO' + i];
            dataSet[i].NRDIASPGTOFO = currentRow['NRDIASPGTOFO' + i];
            dataSet[i].__is_new = true;
        }
        
        return dataSet;
    };
    
    this.getFieldPercent = function(index) {
        return {
            name: "VRPERCPGTOFO" + index,
            label: ScreenService.i18n("Percentual"),
            template: "field/text-edit.html",
            validations: {
                range: {
                    min: 0,
                    max: 100
                }
            },
            "mask": {
                "type": "viewFloat",
                "params": {
                    "showSymbol": false,
                    "precision": 2,
                    "thousands": ".",
                    "decimal": ","
                }
            },
            isVisible: true,
            showOnList: true,
            showOnForm: true,
            class: 5
        };
    };
    
    this.getFieldDelete = function(index) {
       return {
            name: "BTNDELETE" + index,
            label: ScreenService.i18n("Excluir"),
            template: "field/label-with-icon.html",
            isVisible: true,
            icon: "trash",
            showOnList: true,
            showOnForm: true,
            events: [
                {
                    "name":"FieldOnClick",
                    "code":"cmp00100ProdutoPorFornecedorController.deleteFields(args.owner.field)"
                }
            ],
            class: 2
       }; 
    };
    
    this.deleteFields = function(fieldRemove) {
        const widget = fieldRemove.widget;
        const fields = widget.fields;
        const currentRowWidget = widget.currentRow;
        const indexDelete = Number.parseInt(fieldRemove.name.replace('BTNDELETE',''));
        
        for(let i = 0; i<fields.length; i++) {
            let index = Number.parseInt(fields[i].name.replace(/(BTNDELETE|VRPERCPGTOFO|NRDIASPGTOFO)/g,''));
            
            if (index === indexDelete) {
                Number.parseFloat(currentRowWidget[fields[i].name]);
                
                delete currentRowWidget[fields[i].name];
                
                fields.splice(i,1);
                
                i--;
            } else if (index > indexDelete) {
                let nameFieldAntigo = fields[i].name;
                
                fields[i].name = nameFieldAntigo.replace(index,index-1);
                currentRowWidget[fields[i].name] = currentRowWidget[nameFieldAntigo];
                Number.parseFloat(currentRowWidget[fields[i].name]);
                
                delete currentRowWidget[nameFieldAntigo];
            }
        }
        
        self.numRowFormPgto--;
        self.hideDelete(widget);
    };
    
    this.closeFormaPgto = function(widget) {
        widget.fields = [];
        ScreenService.goBack();
        self.numRowFormPgto = 0;
    };
    
    this.setGridPagamento = function(widget) {
        widget.container.getWidget('modopagamento').dataSourceFilter = [
		    {
		        "name": "P_CDFORNECED",
		        "operator": "=",
		        "value": widget.appliedFilter.FILTER_ROW.CDFORNECED
		    },
		    {
		        "name": "P_CDPRODUTO",
		        "operator": "=",
		        "value": widget.currentRow.CDPRODUTO
		    }
		];
		
	    widget.container.getWidget('modopagamento').reload();
    };
    
    /*
     * Campo para alterar a obrigatoriedade do campo de produto ao se adicionar um novo produto. 
     */
    
    this.ativarRequiredProdutos = function(widget, ativar) {
        if (ativar) {
            widget.container.getWidget('adicionaFilial').getField('NMPRODUTO').validations = {
                required: "Campo obrigatório."
            };
        } else {
            widget.container.getWidget('alterAutoWidget').getField('NMPRODUTO').validations = {}; 
        }
    };
    
    /*
     * Função para filtrar os produtos conforme o produto inicial e produto final sejam selecionados. Caso não haja 
     * seleção em ambas as partes, nenhum produto será retornado.
     */
    this.preencheCaracterDireta = function(string) {
        const pad = 'ZZZZZZZZZZ';
        return string + pad.substr(0, pad.length - string.length);    
    };
    
    this.limpaFields = function(widget) {
        widget.currentRow = {};
        widget.reload();
    };
    
    this.filtrarProdutosAlteracaoAutomatica = function(field) {
        const currentRowWidget = field.widget.currentRow;
        
        if (currentRowWidget.CDARVPRODINI && currentRowWidget.CDARVPRODFIN){
            field.widget.getField('NMPRODUTO').dataSourceFilter = [
                {
                    name: "CDPRODINI",
                    operator: "=",
                    value: currentRowWidget.CDARVPRODINI
                },
                {
                    name: "CDPRODFIN",
                    operator: "=",
                    value: self.preencheCaracterDireta(currentRowWidget.CDARVPRODFIN)
                }                
            ];
        } else {
            field.widget.getField('NMPRODUTO').dataSourceFilter = [
                {
                    name: "CDPRODINI",
                    operator: "=",
                    value: null
                },
                {
                    name: "CDPRODFIN",
                    operator: "=",
                    value: 'zzzzzzzzzz'
                }                
            ];            
        }
        
        field.reload();
    };
    
    /*
    this.verifyMaxLength = function(field, maxLength) {
        const value = field.value();
        
        if (value.toString().length > maxLength) {
            const newValue = value.toString().substr(0, maxLength);
            field.setValue(newValue);
        }
    };
    */
    
    this.verifyMaxValue = function(widget, name, maxValue) {
        let value = widget.currentRow[name];
        
        if (typeof(value) == 'string') {
            value = value.split('.').join('');
            value = value.replace(',', '.');
        } 
        
        if (value && parseFloat(value) > parseFloat(maxValue)){
            widget.getField(name).clearValue();
            MessageService.showMessageByCode("VALUE_ABOVE_ALLOWED", {MAX_VALUE: maxValue}, Constants.alertMessage);
        }
    };
    
    this.verifyMinValue = function(widget, name, minValue) {
        let value = widget.currentRow[name];
        
        if (typeof(value) == 'string') {
            value = value.split('.').join('');
            value = value.replace(',', '.');
        } 
        
        if (value && parseFloat(value) < parseFloat(minValue)){
            widget.getField(name).clearValue();
            MessageService.showMessageByCode("VALUE_BELOW_ALLOWED", {MIN_VALUE: minValue}, Constants.alertMessage);
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('cmp00100ProdutoPorFornecedorController', cmp00100ProdutoPorFornecedorController);
});