function Sup03000Controller(ScreenService, General, Sup03000Service, localStorageEngine, Parametros) {
    var centralCompra = false;
    var idutmenpreclt = false;
    var ajuste = 0;

    this.parametros = function() {
		Sup03000Service.retornaFilial().then(function(callback) {
		    var	unidade = callback.dataset.filial[0];
			centralCompra = unidade.CDFILCENTCMP ? unidade.CDFILCENTCMP : unidade.CDFILIAL;
			Parametros.parasupri(centralCompra).then(function(parasupri) {
				idutmenpreclt = parasupri.dataset.parasupri.length ? parasupri.dataset.parasupri[0].IDUTMENPRECLT : "N";
			});
		});
	};

    this.habilitaCampos = function(widget) {
        if (!widget.currentRow.NMFILIAL) {
            widget.getField('TODOSPROD').readOnly = true;
            widget.getField('TODOSPROD').validations = {};
        } else {
            widget.getField('TODOSPROD').readOnly = false;
            widget.getField('TODOSPROD').validations = {required: true};
        }
    };

    this.completaSemanaValidade = function(currentRow) {
        if (currentRow.DTFINVALCOL) {
            currentRow.SEMANAVALIDADE = moment(currentRow.DTFINVALCOL, "DD/MM/YYYY").week();
        } else {
            currentRow.SEMANAVALIDADE = " ";
        }
    };

    this.completaSemana = function(currentRow) {
        if (currentRow.DTINIVALITM) {
            currentRow.SEMANADTINI  = moment(currentRow.DTINIVALITM, "DD/MM/YYYY").week();
        }
        if (currentRow.DTFINVALITM) {
            currentRow.SEMANADTFIM = moment(currentRow.DTFINVALITM, "DD/MM/YYYY").week();
        }
    };

    this.listaSemanas = function(widget) {
        var currentRow = widget.currentRow;
        General.onClickDependentField(widget.getField('NMOPERADOR'), {CDFILIAL: centralCompra, DTFINVALCOL: currentRow.DTFINVALCOL, CDREGIAO: currentRow.CDREGIAO});
    };

    this.limpaCurrentRow = function(widget, field) {
        if(!widget.currentRow.field) {
            var fieldNames = ['NMOPERADOR', 'DTINIVALITM', 'DTFINVALITM', 'SEMANADTINI', 'SEMANADTFIM'];
            fieldNames.forEach(function(fieldName) {
                if ( (widget.getField(fieldName)) && (widget.getField(fieldName).value().length > 0) )
                    widget.getField(fieldName).setValue('');
            });
        }
    };

    this.filter = function(stripeWidget, filterWidget) {
        if(filterWidget.isValid()) {
            var cdfilial = filterWidget.currentRow.CDFILIAL ? filterWidget.currentRow.CDFILIAL : centralCompra;
            Sup03000Service.retornaAjuste(cdfilial, getLocalVar('NRORG')).then(function(callback){
                ajuste = callback.dataset.sup03000Ajuste.length ? callback.dataset.sup03000Ajuste[0].VRPERAJTFORNFIL : 0;
            });

            if(filterWidget.currentRow.NMFILIAL) {
                dataSourceFilter = [
                    { "name": "P_CDFILIAL", "value": filterWidget.currentRow.CDFILIAL, "operator": "=" },
                    { "name": "P_ORDPRPI",  "value": filterWidget.currentRow.ORDPRPI,  "operator": "="},
                    { "name": "P_SISTEMA",  "value": "CMP", "operator": "=" },
                ];
            } else {
                dataSourceFilter = [
                    { "name": "P_CDFILIAL", "value": centralCompra, "operator": "=" },
                    { "name": "P_ORDPRPI",  "value": filterWidget.currentRow.ORDPRPI, "operator": "=" },
                    { "name": "P_SISTEMA",     "value": "SUP", "operator": "=" },
                ];
            }

            var completaDataSourceFilter = [
                { "name": "P_DTINIVALITM", "value": filterWidget.currentRow.DTINIVALITM, "operator": "=" },
                { "name": "P_DTFINVALITM", "value": filterWidget.currentRow.DTFINVALITM, "operator": "=" },
                { "name": "P_CDREGIAO",    "value": filterWidget.currentRow.CDREGIAO,    "operator": "=" },
                { "name": "P_CDOPERADOR",  "value": filterWidget.currentRow.CDOPERADOR,  "operator": "="},
                { "name": "P_TODOSPROD",   "value": filterWidget.currentRow.TODOSPROD,   "operator": "="},
                { "name": "P_DTPROCESSA",  "value": '', "operator": "=" }
            ];

            dataSourceFilter = dataSourceFilter.concat(completaDataSourceFilter);
            filterWidget.getParent().dataSourceFilter = dataSourceFilter;
            filterWidget.getParent().reload();
            this.setaStripe(stripeWidget, filterWidget);
            ScreenService.closePopup();
        }
    };

    this.calculaAjuste = function(widget){
        var dados = widget.dataSource.data;
        var result;
        for (indice = 0; indice < dados.length; indice++) {
            if (idutmenpreclt == 'S') {
                result = dados[indice].VRPRECUNIITM - (dados[indice].VRPRECUNIITM * dados[indice].VRPERPIFORN / 100) + (dados[indice].VRPRECUNIITM * ajuste / 100);
            } else {
                result = dados[indice].VRPRECUNIITM + (dados[indice].VRPRECUNIITM * ajuste / 100);
            }
            dados[indice].PRECO = result.toString().replace('.', ',');
        }
    };

    this.retiraHoraData = function(widget) {
        var dataSourceWidget = widget.dataSource.data;

        for(var posicao in dataSourceWidget) {
            dataSourceWidget[posicao].DTFINVALITM = dataSourceWidget[posicao].DTFINVALITM.split(" ")[0];
            dataSourceWidget[posicao].DTINIVALITM = dataSourceWidget[posicao].DTINIVALITM.split(" ")[0];
        }
    };

    this.setaStripe = function(stripeWidget, filterWidget) {
        stripeWidget.getField('regiao').setValue(filterWidget.currentRow.CDREGIAO + ' - ' + filterWidget.currentRow.NMREGIAO);
        stripeWidget.getField('listaPreco').setValue(filterWidget.currentRow.NMOPERADOR);
        stripeWidget.getField('validade').setValue(filterWidget.currentRow.DTINIVALITM + ' a ' + filterWidget.currentRow.DTFINVALITM);

        if(filterWidget.currentRow.CDFILIAL) {
            stripeWidget.getField('unidade').isVisible = true;
            stripeWidget.getField('unidade').setValue(filterWidget.currentRow.CDFILIAL + ' - ' + filterWidget.currentRow.NMFILIAL);
        } else {
            stripeWidget.getField('unidade').isVisible = false;
            stripeWidget.getField('unidade').setValue('');
        }
    };

    this.prazoDePagamento = function(currentRow, widgetPagamento) {
        var cdfilial      = currentRow.CDFILIAL;
        var nrcolepreco   = currentRow.NRCOLEPRECO;
        var cdproduto     = currentRow.CDPRODUTO;
        var cdmarca       = currentRow.CDMARCA;
        var cdregiao      = currentRow.CDREGIAO;
        var cdfornecedor  = currentRow.CDFORNECED;

        Sup03000Service.retornaPrazoPagamento(cdfilial, nrcolepreco, cdproduto, cdmarca, cdregiao, cdfornecedor).then(function(callback) {
            widgetPagamento.dataSource.data = callback.dataset.sup03000pagamento;
            ScreenService.openPopup(widgetPagamento);
            widgetPagamento.container.getWidget('tab_sup03000_listaPreco').activate();
        });

    };

    this.voltarView = function(widgetMaster) {
        ScreenService.closePopup();
        widgetMaster.currentWidget = widgetMaster;
        widgetMaster.activate();
        widgetMaster.view();
    };
    
    this.fieldRegiaoOnChange = function(widget) {
        var fieldFilial = widget.getField('NMFILIAL');
        
        if (Util.isEmptyOrBlank(widget.getField('NMREGIAO').value())) {
            fieldFilial.readOnly = true;
            //fieldFilial.validations = {required: false};
        } else {
            fieldFilial.readOnly = false;
            //fieldFilial.validations = {required: true};
        }
        
        fieldFilial.setValue('');
        
        if(!fieldFilial.readOnly) {
            fieldFilial.dataSourceFilter[0].value = widget.currentRow.CDREGIAO;
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Sup03000Controller', Sup03000Controller);
});